<?php
/*    This file is part of Zzzt!.
    Copyright (C) 2009  Antonio Ho, José Jorge

    Zzzt! is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zzzt! is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zzzt! .  If not, see <http://www.gnu.org/licenses/>.
*/
require '../inverter/class_inverter.php';
session_start();// after the needed classes
$inverter=new inverter();
$db=new db($inverter);
if(!isset($_GET['year'])) $_GET['year']=date('Y');
$mois=$annees=$values=array();

$sql="SELECT DATE_FORMAT(date,'%M') AS month, date, production FROM zzzt_monthly
      ORDER BY date ASC";
$db->query($sql);
$max12=0;
while ($row = $db->fetch()) {
  $mois[]=$row['month'];
  $values['pac'][]=$row['production'];
  $max12++;
  if($max12 == 12) {$max12=0;$annees[]=$values;$values=array();}
}
$annees[]=$values;

require_once "../artichow/LinePlot.class.php";


$graph = new Graph($_GET['width'], $_GET['height']);
// $graph->setAntiAliasing(TRUE);
$group = new PlotGroup;
$group->grid->setType(Line::DASHED);
$group->grid->setInterval(1,10);

$group->setPadding(45, 10, 5, 15);

$group->axis->left->setLabelNumber(4);
$group->axis->left->setLabelPrecision(1);
$group->axis->left->setTickStyle(Tick::OUT);

function format($value) {
     	return $value;
}

function plot_model($value,$r,$v,$b,$label) {
	global $group;
	$plot = new LinePlot($value);
	$plot->setColor(new Color($r, $v, $b, 10));
	$plot->setFillColor(new Color($r, $v, $b, 90));
// 	$group->legend->add($plot, mb_convert_encoding($label,'ISO-8859-1','UTF-8'), Legend::MARK);

	//valeurs sur les lignes
	if(isset($_GET['reduce'])) $plot->reduce($_GET['reduce']);
	if(isset($_GET['hideLine'])) $plot->hideLine($_GET['hideLine']);
	$plot->mark->setType(Mark::CIRCLE);
	$plot->mark->setSize(1);
	$plot->label->set($value);
	$plot->label->setInterval(30);//toutes les 3 valeurs
	$plot->label->hideFirst(TRUE);
	$plot->label->setPadding(1, 1, 1, 1);
	$plot->label->setCallbackFunction('format');
	$plot->label->setBackgroundColor(new Color(227, 223, 241, 15));
	$plot->label->setFont(new Tuffy(7));


	$group->add($plot);
}

function rd() {return rand(30,200);}
// var_dump($annees);echo '<br>';
foreach ($annees as $values)
  if ( sizeof($values)>0) plot_model($values['pac'],rd(),rd(),rd(),'kWh/'.DMT);

// barre des KWh
function setK($value) {
    return round($value).'KWh';
}
$group->axis->left->label->setCallbackFunction('setK');

// heures en bas
function setTime($value) {
	global $mois;
	$return=$mois[$value];
	return $return;
}
$group->axis->bottom->label->setCallbackFunction('setTime');
$group->axis->bottom->setTickInterval(10);
//l�gende
$group->legend->setPosition(0.7, rand(1,5)/10);
$group->legend->setBackgroundColor(new Color(255, 255, 255, 255));
$group->legend->shadow->smooth(TRUE);

$graph->add($group);

$graph->draw();
?>