<?php
/*    This file is part of Zzzt!.
    Copyright (C) 2009  Antonio Ho, José Jorge

    Zzzt! is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zzzt! is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zzzt! .  If not, see <http://www.gnu.org/licenses/>.
*/
require '../inverter/class_inverter.php';
session_start();// after the needed classes
$inverter=new inverter();
  if(!isset($_GET['day'])) $_GET['day']=date('Y-m-d');
  if(!isset($_GET['width'])) $_GET['width']=1000;
  if(!isset($_GET['height'])) $_GET['height']=200;
  if(!isset($_GET['data'])) $_GET['data']='pac';

  $db=new db($inverter);
  $heure=array();
  $values=array();

  $sql="SELECT UNIX_TIMESTAMP(monitor_date) AS monitor_date,pac,pdc,kdy,tkk FROM zzzt
	WHERE DATE(`monitor_date`)='{$_GET['day']}'ORDER BY monitor_date ASC";
  $db->query($sql);
//   echo $sql;
  while ($row = $db->fetch())
  {
	if(!isset($next) || $row['monitor_date']>$next) {//supprime les même minutes de sources différentes
		if(isset($next)) {
			while($row['monitor_date']>$next) {// remplit les zones vides
				$next+=30;
				$heure[]=date('H:i',$next);
				$values[$_GET['data']][]=NULL;
			}
			array_pop($heure);array_pop($values[$_GET['data']]);//il y en a un de trop
		}
		$heure[]=date('H:i',$row['monitor_date']);
		$next=$row['monitor_date']+30;//we want at least 50 seconds more
		if($_GET['data']=='rendement') $values[$_GET['data']][]=sprintf('%.2F',$row['pac']/($row['pdc']+0.0001)*100);
		else $values[$_GET['data']][]=$row[$_GET['data']];
// 		echo date('H:i',$row['monitor_date']).' '.$row['pac'].'<br>';
	}
  }
//  echo count($heure);

//  var_dump($values);exit();
require_once "../artichow/LinePlot.class.php";


$graph = new Graph($_GET['width'], $_GET['height']);
// $graph->setAntiAliasing(TRUE);
$group = new PlotGroup;
$group->grid->setType(Line::DASHED);
$group->grid->setInterval(1,100);

$group->setPadding(-1, 1, 5, 15);

$group->axis->left->setLabelNumber(8);
$group->axis->left->setLabelPrecision(1);
$group->axis->left->setTickStyle(Tick::OUT);

function format($value) {
     	return $value;
}

function plot_model($value,$r,$v,$b,$label) {
	global $group;
	$plot = new LinePlot($value);
	$plot->setColor(new Color($r, $v, $b, 10));
	$plot->setFillColor(new Color($r, $v, $b, 90));
	$group->legend->add($plot, mb_convert_encoding($label,'ISO-8859-1','UTF-8'), Legend::MARK);

	//valeurs sur les lignes
	if(isset($_GET['reduce'])) $plot->reduce($_GET['reduce']);
	if(isset($_GET['hideLine'])) $plot->hideLine($_GET['hideLine']);
	if(isset($_GET['setYMin'])) $plot->setYMin($_GET['setYMin']);
	$plot->mark->setType(Mark::CIRCLE);
	$plot->mark->setSize(1);
	$plot->label->set($value);
	$plot->label->setInterval(60);//toutes les 6 valeurs
	$plot->label->hideFirst(TRUE);
	$plot->label->setPadding(1, 1, 1, 1);
	$plot->label->setCallbackFunction('format');
	$plot->label->setBackgroundColor(new Color(227, 223, 241, 15));
	$plot->label->setFont(new Tuffy(7));


	$group->add($plot);
}

function rd() {return rand(30,200);}

plot_model($values[$_GET['data']],rd(),rd(),rd(),$_GET['data']);

// barre des KWh
function setK($value) {
    return round($value).'KWh';
}
$group->axis->left->label->setCallbackFunction('setK');

// heures en bas
function setTime($value) {
	global $heure;
	if($value % 120 == 1) $return=$heure[$value];
	else $return='';
	return $return;
}
$group->axis->bottom->label->setCallbackFunction('setTime');
$group->axis->bottom->setTickInterval(60);
//l�gende
$group->legend->setPosition(0.7, rand(1,5)/10);
$group->legend->setBackgroundColor(new Color(255, 255, 255, 255));
$group->legend->shadow->smooth(TRUE);

$graph->add($group);

$graph->draw();
?>