<?php
/*    This file is part of Zzzt!.
    Copyright (C) 2009-2016  Antonio Ho, José Jorge

    Zzzt! is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Zzzt! is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Zzzt! .  If not, see <http://www.gnu.org/licenses/>.
*/
  require '../inverter/class_inverter.php';
  session_start();// after the needed classes
  $inverter=new inverter();
  $db=new db($inverter);
  $heure=array();
  $values=array();
  $champs=array('pac','pdc','kdy','tkk');
  isset($_GET['day']) ? $day=$_GET['day'] : $day=date('Y-m-d');
  if(!isset($_GET['width'])) $_GET['width']=1000;
  if(!isset($_GET['height'])) $_GET['height']=550;
  $sql="SELECT ROUND(DATE_FORMAT(monitor_date,'%H%i'),0) AS md,
              ROUND(AVG(pac),0) AS pac,
              ROUND(AVG(pdc),0) AS pdc,
              kdy, tkk FROM zzzt
        WHERE DATE(`monitor_date`)='$day' GROUP BY md ORDER BY md ASC";
  $db->query($sql);
  while ($row = $db->fetch()) {
    if(isset($prev) && !isset($_GET['detaille']) &&
        ( ($prev<=$row['pdc'] && $prev*1.03>=$row['pdc']) || ($prev>=$row['pdc'] && $prev*0.97<=$row['pdc']) ) 
      ) {$skip+=1;} else {$skip=0;}
    if($skip<1 || $skip>9) {
      $prev=$row['pdc'];
      $heure[]=$day.' '.implode(':',str_split(str_pad((int)$row['md'],4,"0",STR_PAD_LEFT),2));
      $values['rendement'][]=sprintf('%.2F',$row['pac']/($row['pdc']+0.0001)*100);
      foreach($champs as $c) $values[$c][]=$row[$c];
    }
  }
  htmlCommun($day);
?>

<body>
  <b><a href=../inverter/index.php><?php echo APPLICATION;?></a></b>
  <a href=daily.php><?php echo BY_DAY;?></a>
  <a href=monthly.php><?php echo BY_MONTH;?></a>
  <a href=yearly.php><?php echo KYR;?></a>
  <?php echo DAY_PROD;?>
  
  <table><tr><TD>
    <form action=index.php method=get>
      <?php echo DDY;?> :
      <select name=day>
        <?php
          $demain=date('Y-m-d', strtotime($day)+(3600*24) );
          $hier=date('Y-m-d', strtotime($day)-(3600*24) );
          if(!isset($_GET['width'])) $_GET['width']=600;
          $fixe="image_day.php?day={$day}&amp;width={$_GET['width']}&amp;data=";

          for($i=0;$i<10;$i++){
            $d=date('Y-m-d', strtotime($day)-(3600*24*$i) );
            $d==$day ? $selected='selected' : $selected='';
            $bd=strftime("%e %b %G",strtotime($day)-(3600*24*$i));
            echo "<option value='$d' $selected >$bd</option>\n";
          }
        ?>
      </select>
      
      <noscript><?php echo GRAPH_WIDTH.' :';?><input type=text size=4 name=width value='<?php echo $_GET['width'];?>'></noscript>
      <input type=checkbox name='detaille' value='1' title='++' <?php if( isset($_GET['detaille']) ) echo 'checked';?> >
      <input type=submit>
    </form>
    
    </td><TD>
    <a href=index.php?day=<?php echo $hier;?>&width=<?php echo $_GET['width'];?>>¤-1</a> / 
    <a href=index.php?day=<?php echo $demain;?>&width=<?php echo $_GET['width'];?>>¤+1</a>
    </TD></tr>
    <tr><TD colspan=3>
      <script type="text/javascript">
        document.write("<div id=\"holderP\"></div>");
        document.write("<div id=\"holderR\"></div>");
      </script>
      <noscript>
      <img src='<?php echo $fixe;?>pac&amp;height=300' title='<?php echo PAC;?>' alt='<?php echo PAC;?>'>
    </TD></tr>
    <tr><TD colspan=3>
      <img src='<?php echo $fixe;?>kdy&amp;height=150' title='<?php echo KDY;?>' alt='<?php echo KDY;?>'>
    </TD></tr>
    <tr><TD colspan=3>
      <img src='<?php echo $fixe;?>rendement&amp;height=150&amp;setYMin=80' title='<?php echo EFFICIENCY;?>' alt='<?php echo EFFICIENCY;?>'>
    </TD></tr>
    <tr><TD colspan=3>
      <img src='<?php echo $fixe;?>tkk&amp;height=100&amp;setYMin=20' title='<?php echo TKK;?>' alt='<?php echo TKK;?>'>
      </noscript>
    </TD></tr>
    <tr><TD colspan=3>
<?php
  $sql="SELECT YEAR(date) AS year, production
              FROM zzzt_daily
        WHERE DAY(date) = DAY('$day')
        AND MONTH(date) = MONTH('$day')
        ORDER BY year DESC";
  $db->query($sql);
  $ap=strftime("%e %B %G", strtotime($day))."
";
  while ($row = $db->fetch()) $ap.=DYR." {$row['year']} : {$row['production']} kWh
";

  // Average for last 20 minutes
  $db->query("SELECT MIN(kdy) FROM `zzzt` WHERE `monitor_date` BETWEEN SUBTIME(NOW(),'00:21:00') and SUBTIME(NOW(),'00:19:00')");
  list($kdy20)= $db->fetch();
  if ($kdy20 != NULL) {
    $db->query("SELECT kdy FROM `zzzt` ORDER BY monitor_date DESC LIMIT 0,1");
    list($kdynow)= $db->fetch();
    $ap.=AVG.D20_MN. ($kdynow-$kdy20)*3000 ." W";
  }

  echo "<a title='$ap'>".LAST_MEASURES."</a>";
  $sql="SELECT * FROM zzzt
          WHERE DATE(monitor_date) = '{$day}'
          ORDER BY monitor_date DESC
          LIMIT 0,5";
  $db->query($sql);
  $titre='      <tr>
                        <th>'.DYR.'-'.DMT.'-'.DDY.' '.THR.':'.TMI.'</th>
                        <th>'.EFFICIENCY.'</th>
                        <th>'.PAC.'</th>
                        <th>'.PDC.'</th>
                        <th>'.KDY.'</th>
                        <th>'.TKK.'</th>
                        <th>'.MONITOR.'</th>
                </tr>';
  echo '
        <table border=1>';
  $monitors=array();
  while ($row = $db->fetch())
  {
    if(!array_key_exists($row[5],$monitors)) {
      $monitors[$row[5]]='#'.dechex(rand(106,254)).dechex(rand(106,254)).dechex(rand(106,254));
    }
        echo"<tr style='background-color:{$monitors[$row[5]]}'>
                <td>$row[0]</td>
                <td>".sprintf('%.2F',$row[1]*100/($row[2]+0.0001))."%</td>
                <td>$row[1]</td>
                <td>$row[2]</td>
                <td>$row[3]</td>
                <td>$row[4]</td>
                <td>$row[5]</td>
        </tr>";
  }
  echo $titre;
  $sql="SELECT * FROM (
            SELECT * FROM zzzt WHERE DATE(monitor_date) = '{$day}' ORDER BY monitor_date ASC LIMIT 0,5 )
            AS zzztdebut ORDER BY monitor_date DESC";
  $db->query($sql);
  while ($row = $db->fetch())
  {
    if(!array_key_exists($row[5],$monitors)) {
      $monitors[$row[5]]='#'.dechex(rand(106,254)).dechex(rand(106,254)).dechex(rand(106,254));
    }
        echo"<tr style='background-color:{$monitors[$row[5]]}'>
                <td>$row[0]</td>
                <td>".sprintf('%.2F',$row[1]*100/($row[2]+0.0001))."%</td>
                <td>$row[1]</td>
                <td>$row[2]</td>
                <td>$row[3]</td>
                <td>$row[4]</td>
                <td>$row[5]</td>
        </tr>";
  }
  echo '</table>';
?>
    </TD></tr>
  </table>
  
  <div id='etat' title='<?php echo LAST_MEASURES;?>'>
    <div id='last' title='<?php echo sizeof($values['rendement']); ?>'></div>
    <progress id='temps' max='6' value='0'></progress>
  </div>
  
  </body>
  
<script type="text/javascript" charset="utf-8">
 var tabP = [
  <?php
    for($i=0;$i<sizeof($values['pac']);$i++) {
      echo "{ h: '".$heure[$i]."'";
      echo ", 'k': ".$values['kdy'][$i]*100;
      echo ", 'a': ".$values['pac'][$i];
      echo ", 'd': ".$values['pdc'][$i];
     if($i<sizeof($values['pac'])-1) echo " },\n"; else echo " }\n";
    }
  ?>
  ];
        
 var chartP = Morris.Area({
        element: 'holderP',
        lineColors: ['#006600','#FF3300','#006699'],
        pointSize: 0,
        smooth: false,
        behaveLikeLine: true,
        fillOpacity: 0.5,
        hideHover: 'auto',
        lineWidth: 1,
        data: tabP,
        resize: true,
        redraw: true,
        xkey: 'h',
        ykeys: ['k','a','d'],
        labels: ['<?php echo KDY;?> (daWh)','<?php echo PAC;?> (W)','<?php echo PDC;?> (W)'] });

 var tabR = [
  <?php
    for($i=0;$i<sizeof($values['rendement']);$i++) {
      echo "{ h: '".$heure[$i]."'";
      echo ", 'r': ".$values['rendement'][$i];
      echo ", 't': ".$values['tkk'][$i];
      if($i<sizeof($values['rendement'])-1) echo " },\n"; else echo " }\n";
    }
  ?>
  ];
  
 var chartR = Morris.Line({
          element: 'holderR',
          lineColors: ['#1751A7','#006600'],
          pointSize: 0,
          hideHover: 'auto',
          lineWidth: 1,
          data: tabR,
          resize: true,
          redraw: true,
          xkey: 'h',
          ykeys: ['r','t'],
          labels: ['<?php echo EFFICIENCY;?>','<?php echo TKK;?>'] });

  if (typeof tabP[0] !== 'undefined') {
    document.getElementById("last").innerHTML = 
      tabP[tabP.length-1]['h'].substr(-5,5)+' ' +
      tabP[tabP.length-1]['a']+'W ' +
      tabP[tabP.length-1]['k']/100+'kWh';
  }
 
</script>
  
<?php if(!isset($_GET['day'])) echo '<script src="update.js" type="text/javascript"></script>'; ?>
  
</html>
